/*
  File: Meters.h
  Purpose: Definitions for execution metering.
  Author:  James Painter
  Last Modified: December 7, 1985
*/
#include <REAL.h>

typedef struct
 {
   int PathsSearched;
   int NodesFilled;    /* For optimal path finding */
   int BottleNeckCost;  /* For the bottleneck search */
   REAL UserCpuTime, SystemCpuTime;
 } MetersType;

extern MetersType Meters;
extern void StartClock(), StopClock(), PrintMeters(), ResetMeters();

